// CustomScale_v2.mq4 corrected by loopsider 04.06.2015
// Instead of numGrid introduced gridSpace
// Added a Bid label, bidColor sets the color
// Had to introduce a number of changes since the number of grid lines now varies
// 
//+---------------------------------------------------------------------------+
//|                                                           CustomScale.mq4 |
//|                                                   Kilian19 @ ForexFactory |
//|                                                                           |
//| Copyright (c) 2015                                                        |
//|                                                                           |
//| Permission to use, copy, modify, and/or distribute this software for any  |
//| purpose with or without fee is hereby granted, provided that the above    |
//| copyright notice and this permission notice appear in all copies.         |
//|                                                                           |
//| THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES  |
//| WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF          |
//| MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR   |
//| ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    |
//| WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN     |
//| ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF   |
//| OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.            |
//|                                                                           |
//+---------------------------------------------------------------------------+

//NOT PERFORMANCE Optimized!


#property copyright "Kilian19 @ ForexFactory"
#property link      "kilian19f@gmail.com"
#property version   "1.02"
#property description "Indicator to print custom price labels and a grid on the chart."
#property strict
#property indicator_chart_window
#property indicator_buffers 0

//This import is a little bit heavy weight. We probably could use some of the base classes instead (CShapedObjectLabel) but lets not bother about it for now as it will do the job just fine.
#include <Controls/Panel.mqh>

//--- input parameters
input string   _="------Label Settings------"; 
input color    textColor=clrNONE; //Label Color
input color    bidColor=DarkOrange; //Label Color
input uint     fontSize=10; // Font Size
input int      xLabelOffset = 6;
input int      yLabelOffset  = 0;

input string __ ="------Price Background -------";
bool hideOriginalPrice = true;   //should always be true...
input string ___ ="clrNONE = chartColor";
input color backgroundColor = clrNONE; 
input color borderColor = clrNONE;
input int   widthScale = 30;

input string   spacer1="------Grid Settings------"; //Grid 
bool hideOriginalGrid = true; //should always be true
input color    gridColor=clrDarkGray; // Grid Color
input ENUM_LINE_STYLE gridStyle = STYLE_DOT; //Line Style
input int      gridLineWidth = 1; //Grid Line Width
input string   spacer2="------Pips in the Grid specified timeframe------"; //Pips in the Grid specified timeframe
input int      gridSpaceM1  = 50; //Spacing of grid lines for M1
input int      gridSpaceM2  = 50; //Spacing of grid lines for M2
input int      gridSpaceM3  = 100; //Spacing of grid lines for M3
input int      gridSpaceM4  = 100; //Spacing of grid lines for M4
input int      gridSpaceM5  = 100;//Spacing of grid lines for M5
input int      gridSpaceM6  = 100;//Spacing of grid lines for M6
input int      gridSpaceM10 = 250;//Spacing of grid lines for M10
input int      gridSpaceM12 = 250;//Spacing of grid lines for M12
input int      gridSpaceM15 = 250;//Spacing of grid lines for M15
input int      gridSpaceM20 = 250;//Spacing of grid lines for M20
input int      gridSpaceM30 = 250;//Spacing of grid lines for M30
input int      gridSpaceH1  = 500;//Spacing of grid lines for H1
input int      gridSpaceH2  = 500;//Spacing of grid lines for H2
input int      gridSpaceH3  = 500;//Spacing of grid lines for H3
input int      gridSpaceH4  = 500;//Spacing of grid lines for H4
input int      gridSpaceH6  = 500;//Spacing of grid lines for H6
input int      gridSpaceH8  = 500;//Spacing of grid lines for H8
input int      gridSpaceH12 = 500;//Spacing of grid lines for H12
input int      gridSpaceD1  = 1000;//Spacing of grid lines for D1
input int      gridSpaceW1  = 2500;//Spacing of grid lines for W1
input int      gridSpaceMN1 = 5000;//Spacing of grid lines for MN1


//minimal distance price will be shifted from the edge of the price scale.
#define MIN_SHIFT_DISTANCE_FROM_EDGE (50)

int      gridSpace;
int numGridLines;
double lastWinMin,lastWinMax;
color lableColor,customBackgroundColor,customGridColor;


CPanel background;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(_Period==PERIOD_M1)gridSpace=gridSpaceM1;
   if(_Period==PERIOD_M2)gridSpace=gridSpaceM2;
   if(_Period==PERIOD_M3)gridSpace=gridSpaceM3;
   if(_Period==PERIOD_M4)gridSpace=gridSpaceM4;
   if(_Period==PERIOD_M5)gridSpace=gridSpaceM5;
   if(_Period==PERIOD_M6)gridSpace=gridSpaceM6;
   if(_Period==PERIOD_M10)gridSpace=gridSpaceM10;
   if(_Period==PERIOD_M12)gridSpace=gridSpaceM12;
   if(_Period==PERIOD_M15)gridSpace=gridSpaceM15;
   if(_Period==PERIOD_M20)gridSpace=gridSpaceM20;
   if(_Period==PERIOD_M30)gridSpace=gridSpaceM30;
   if(_Period==PERIOD_H1)gridSpace=gridSpaceH1;
   if(_Period==PERIOD_H2)gridSpace=gridSpaceH2;
   if(_Period==PERIOD_H3)gridSpace=gridSpaceH3;
   if(_Period==PERIOD_H4)gridSpace=gridSpaceH4;
   if(_Period==PERIOD_H6)gridSpace=gridSpaceH6;
   if(_Period==PERIOD_H8)gridSpace=gridSpaceH8;
   if(_Period==PERIOD_H12)gridSpace=gridSpaceH12;
   if(_Period==PERIOD_D1)gridSpace=gridSpaceD1;
   if(_Period==PERIOD_W1)gridSpace=gridSpaceW1;
   if(_Period==PERIOD_MN1)gridSpace=gridSpaceMN1;
   //Since we create our custom grid and price scale we hide the originals.
   ChartSetInteger(ChartID(),CHART_SHOW_PRICE_SCALE,!hideOriginalPrice);
   ChartSetInteger(ChartID(),CHART_SHOW_GRID,!hideOriginalGrid);
   
   //Get some meta data we need !get the data after we disabled the price scale as this will change the width
   int chartWidth = (int)ChartGetInteger(ChartID(),CHART_WIDTH_IN_PIXELS,0);
   int chartHeight = (int)ChartGetInteger(ChartID(),CHART_HEIGHT_IN_PIXELS,0);
   
   //We decide what is good for the user ...
   bool chartShifted = ChartGetInteger(ChartID(),CHART_SHIFT);
   
   //Since our custom price scale will take place on the chart we need to shift everything so we are actually able to see the prize.
   if(!chartShifted)
   {
      ChartSetInteger(ChartID(),CHART_SHIFT,true); 
      ChartNavigate(ChartID(),CHART_END,0); //We need to navigate to the end once because chart shift shifted our candles offset but not our display region
   } 
   //How much shift do we have? We need to check this ot the candles will be underneath the new price scale if auto scroll is enabled.
   double shiftSize = ChartGetDouble(ChartID(),CHART_SHIFT_SIZE);
   double shiftInPixels = chartWidth * (shiftSize/100);
   
   //How much shift do we need?
   int backgroundBegin = chartWidth - widthScale - (int)fontSize*3;
   
   //is is shifted enough or do we have to help a little bit?
   int sizeOfBackground = chartWidth - backgroundBegin;
   if( (shiftInPixels) < sizeOfBackground + MIN_SHIFT_DISTANCE_FROM_EDGE)
   {
      //calculate the % value we need.
      
      /* Dreisatz
      // shiftInPixels       = shiftSize
      //       1             = shiftSize/shiftInPixels
      // sizeOfBackground+50 = (shiftSize/shiftInPixels)* (sizeOfBackground+50)   
      
     Print( "Shift needed: " + (sizeOfBackground+50) + "px");
     Print( "Actual: " + (shiftInPixels) + "px: " + shiftSize + "%");
     */
     double percentShiftNeeded = (shiftSize/shiftInPixels)* (sizeOfBackground+MIN_SHIFT_DISTANCE_FROM_EDGE);
     
     if(percentShiftNeeded > 50)
      percentShiftNeeded = 50; //max allowed value;
      
      ChartSetDouble(ChartID(),CHART_SHIFT_SIZE,percentShiftNeeded);
      ChartNavigate(ChartID(),CHART_END,0); //same as above.
   }
   
   //Color settings
   
   //Set up the grid color. If no color is defined take the original color.
   if(gridColor == clrNONE)
      customGridColor = (color)ChartGetInteger(ChartID(),CHART_COLOR_GRID);
   else
      customGridColor = gridColor;
   
   //Create the price scale background. Its a cPanel defined above this function.
   background.Create(ChartID(),"background",0,backgroundBegin,0,chartWidth,chartHeight);
     
   if(backgroundColor == clrNONE){
      color chartBackgroundColor = (color)ChartGetInteger(ChartID(),CHART_COLOR_BACKGROUND);
      background.ColorBackground(chartBackgroundColor);
   }
   else{
       background.ColorBackground(backgroundColor);
   }
   color customForeGroundColor = (color)ChartGetInteger(ChartID(),CHART_COLOR_FOREGROUND);
   
   //Ignore warnings code is being perfectly fine
   borderColor == clrNONE ? background.ColorBorder(customForeGroundColor) : background.ColorBorder(borderColor);
   textColor == clrNONE ? lableColor = customForeGroundColor : lableColor = textColor;
   
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

//---
      //The chart event should cover all events of chart changes.
      //recalculateLevels();

         //Bid price Label  
      string objName = "GridLabelBid";
      double price = Bid;
      int unused,y;
      ChartTimePriceToXY(ChartID(),0,Time[0],price,unused,y);
      if(ObjectFind(ChartID(),objName) < 0)
      {
         ObjectCreate(objName,OBJ_LABEL,0,0,0);
         ObjectSet(objName,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
         ObjectSet(objName,OBJPROP_XDISTANCE,xLabelOffset);
         ObjectSet(objName,OBJPROP_HIDDEN,true);
         ObjectSet(objName,OBJPROP_SELECTABLE,false); 
      }        
      ObjectSet(objName,OBJPROP_YDISTANCE,y-(int)fontSize+yLabelOffset); //the cast from uint to int is important here ot the calculation will break           
      ObjectSetText(objName,DoubleToString(price,_Digits),fontSize,"Arial",bidColor);
      
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   //update the scale every time the chart changes. 
   //I am not 100% sure if this events covers the creatino of a new bar as well. if autoscroll break the updating process symply delete this if statement.
      if(id == CHARTEVENT_CHART_CHANGE) 
         recalculateLevels();
  }
  
  //Create labels and a grid
  void recalculateLevels(){
   
      //only recalculate if the pricelevel changed 
      double winMin = WindowPriceMin(0);
      double winMax = WindowPriceMax(0);
      
      if(winMin == lastWinMin && winMax == lastWinMax)
         return;
       
      clearChart("GridLabel");  
       
      //Move the background if the chart dimensions changed. We might be able to do this with alignement?
      int chartWidth = (int)ChartGetInteger(ChartID(),CHART_WIDTH_IN_PIXELS,0);
      int chartHeight = (int)ChartGetInteger(ChartID(),CHART_HEIGHT_IN_PIXELS,0);
      int backgroundBegin = chartWidth - widthScale - (int)fontSize*3;

      int width  = chartWidth - backgroundBegin;
      background.Size(width,chartHeight);
      background.Move(backgroundBegin,0);
      
      lastWinMin = winMin; 
      lastWinMax = winMax;
      
      //We only want labels ending with 0 or 5
      
      //Due to modulo operation being only applyable to integer we need to convert the values.
      int startPointMax = (int)(winMax/Point);
      int startPointMin = (int)(winMin/Point);

      startPointMax++;
      startPointMin--;
    
      while( (startPointMax % gridSpace) != 0)
         startPointMax++;
      
      while(startPointMin % gridSpace != 0)
         startPointMin--;
     
      int spacing = gridSpace;
      numGridLines = MathRound((startPointMax-startPointMin)/(1.0*gridSpace))+1;
   
      datetime startTime = Time[Bars(Symbol(),PERIOD_CURRENT)-1]; //Should be okay.
      datetime endTime = Time[0];   //due to ray settings this will extend in the future.
      
      for(int i = 0; i < numGridLines; i++)
      {
         int priceP = startPointMin+i*spacing;
         string objName = "Grid"+IntegerToString(priceP);
         double price = priceP*Point;
         
         //I like to use trendlines instead of horizontal trendlines as they do not have prive labels attached to the side.
         
         if(ObjectFind(ChartID(),objName) < 0)
         {
            ObjectCreate(objName,OBJ_TREND,0,startTime,price,endTime,price);
            ObjectSet(objName,OBJPROP_BACK,true);
            ObjectSet(objName,OBJPROP_RAY,true);
            ObjectSet(objName,OBJPROP_HIDDEN,true);
            ObjectSet(objName,OBJPROP_SELECTABLE,false);
            ObjectSet(objName,OBJPROP_STYLE,gridStyle);
            ObjectSet(objName,OBJPROP_WIDTH,gridLineWidth);
            ObjectSet(objName,OBJPROP_COLOR,customGridColor);
         }
         else
         {  //Only update the important information
            ObjectSet(objName,OBJPROP_PRICE1,price);
            ObjectSet(objName,OBJPROP_PRICE2,price);
            ObjectSet(objName,OBJPROP_TIME1,startTime);
            ObjectSet(objName,OBJPROP_TIME2,endTime);
         }

         //Create the price Label  Recreate text every itteration or use label?
         objName = "GridLabel"+IntegerToString(priceP);
         
         int unused,y;
         ChartTimePriceToXY(ChartID(),0,Time[0],price,unused,y);
         
         
          if(ObjectFind(ChartID(),objName) < 0)
          {
            ObjectCreate(objName,OBJ_LABEL,0,0,0);
            ObjectSet(objName,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
            ObjectSet(objName,OBJPROP_XDISTANCE,xLabelOffset);
            ObjectSet(objName,OBJPROP_HIDDEN,true);
            ObjectSet(objName,OBJPROP_SELECTABLE,false); 
          }
         
         ObjectSet(objName,OBJPROP_YDISTANCE,y-(int)fontSize+yLabelOffset); //the cast from uint to int is important here ot the calculation will break           
         ObjectSetText(objName,DoubleToString(price,_Digits),fontSize,"Arial",lableColor);
      }
  }
  
void OnDeinit(const int reason)
{
   clearChart("Grid");

   //Renable those again
   ChartSetInteger(ChartID(),CHART_SHOW_PRICE_SCALE,true);
   ChartSetInteger(ChartID(),CHART_SHOW_GRID,true);
}  

///     
int clearChart(string prefix_) {
	int obj_total = ObjectsTotal();
	string name;
	int count = 0;
	for (int i = obj_total - 1; i >= 0; i--) {
		name = ObjectName(i);
		if (StringFind(name, prefix_) >= 0) {
			ObjectDelete(name);
			count++;
		}			
	}
	return(count);
}
  
//+------------------------------------------------------------------+
